namespace nkmidi
{
	using System;
	using System.Collections;

	using nkmidi.Meta;

	/// <summary>
	/// MIDITrack: 1gbNMIDIf[^\NX
	/// </summary>
	public class MIDITrack
	{
		private ArrayList events;

		public MIDITrack() 
		{
			events = new ArrayList();
		}

		public void addEvent(MIDIEvent ev) 
		{
			events.Add(ev);
		}

		public MIDIEvent[] getEvents()
		{
			return (MIDIEvent[])events.ToArray( events[0].GetType() );
		}
	}

	/// <summary>
	/// MIDIEvent: MIDICxg\NX
	/// </summary>
	public class MIDIEvent
	{
		private byte[] rawData;
		private uint deltaTime;
		private bool isSysexEvent;
		private MetaEvent metaEvent;

		public MIDIEvent()
		{
			this.RawData = null;
			this.DeltaTime = 0;
			this.IsSysexEvent = false;
			this.MetaEvent = null;
		}

		// accessors and properties

		public byte[] RawData
		{
			get { return rawData; }
			set { rawData = value; }
		}

		public uint DeltaTime
		{
			get { return deltaTime; }
			set { deltaTime = value; }
		}

		public bool IsSysexEvent
		{
			get { return isSysexEvent; }
			set { isSysexEvent = value; }
		}

		public MetaEvent MetaEvent
		{
			get { return metaEvent; }
			set { metaEvent = value; }
		}

		public bool IsMetaEvent
		{
			get { return (metaEvent != null); }
		}
	}
}
